/*************************************************************
All you ever wanted to know and less about the RING Cycle.
Created by Peter Roosen-Runge


 read  :-   as "if"
       ,    as "and"
       ;    as "or"
       .    end of fact or rule

*************************************************************/

/**** Nasties ****/

dragon(fafner).
giant(fasolt).             giant(fafner).
brother(mime,alberich).    brother(fasolt,fafner).
brother(gunther,hunding).  son(hagen,alberich).

bass(fafner).           bass(hunding).

/**** Noisies ****/

valkyrie(brunnhilde).	valkyrie(gerhilde).	valkyrie(waltraute). 
valkyrie(schwertleite).	valkyrie(helmwige).	valkyrie(seigrune).
valkyrie(grungerde).	valkyrie(rossweise).

/**** Heroes ****/

hero(siegfried).	hero(siegmund).

/**** Lovers ****/

loves(brunnhilde,siegfried).
loves(sieglinde,siegmund).

/**** Some general rules ****/

tenor(X) :- hero(X).
noisy(X) :- valkyrie(X) ; tenor(X).

dwarf(alberich).
dwarf(X) :- son(X,Y), dwarf(Y).
dwarf(X) :- brother(X,Y), dwarf(Y).

nogood(X) :- dwarf(X) ; giant(X) ; bass(X).

dies(X) :- bass(X).
dies(X) :- hero(X).
dies(X) :- brother(X,Y), nogood(Y).
dies(X) :- loves(X,Y), hero(Y).


/**** Curses ****/

got_ring_from(alberich, rhine_maiden).
got_ring_from(wotan,alberich).
got_ring_from(fafner,wotan).
got_ring_from(siegfried,fafner).
got_ring_from(brunnhilde,siegfried).
got_ring_from(siegfried,brunnhilde). /* pretending to be Gunther */
got_ring_from(gunther,siegfried).
got_ring_from(hagen,gunther).
got_ring_from(brunnhilde,hagen).
got_ring_from(rhine_maiden,hagen).

cursed(wotan) :- !.
/* cursed(X) :- got_ring_from(X,Y), cursed(Y), not(X=rhine_maiden). */
